/**
 * Copyright (C) 2010 Gauvain Pocentek <gpocentek@linutop.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef WK_DAEMON_H
#define WK_DAEMON_H

#include <glib.h>
#include <dbus/dbus-glib.h>

#include "wk-slideshow-item.h"
#include "wk-settings.h"

typedef enum {
    WK_DAEMON_STATUS_BROWSER,
    WK_DAEMON_STATUS_SLIDESHOW,
    WK_DAEMON_STATUS_INVALID,
} WkDaemonStatus;

typedef struct _WkDaemon {
    WkSettings *settings;
    GSList *playlist;
    GSList *next_playlist;
    volatile gint do_pl_switch;
    GSList *current;
    guint timeout_id;
    WkDaemonStatus status;
} WkDaemon;

WkDaemon *wk_daemon_get ();

void wk_daemon_start (WkDaemon *d);
void wk_daemon_end   (WkDaemon *d);

void wk_daemon_start_slideshow (WkDaemon *d);
void wk_daemon_handle_stop_session  (WkDaemon *d);
void wk_daemon_handle_start_session (WkDaemon *d);
void wk_daemon_handle_video_end (WkDaemon *d);

#endif /* !WK_DAEMON_H */

