/**
 * Copyright (C) 2010 Gauvain Pocentek <gpocentek@linutop.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef WK_SLIDESHOW_ITEM
#define WK_SLIDESHOW_ITEM

#include <glib.h>

#include "enums.h"

typedef struct _WkSlideshowItem {
    int timeout;
    WkSlideshowItemType type;
    gchar *uri;
} WkSlideshowItem;

WkSlideshowItem *wk_slideshow_item_new (const char *uri,
                                        WkSlideshowItemType type,
                                        int timeout);

WkSlideshowItemType wk_slideshow_item_guess_type (const gchar *uri);

void wk_slideshow_item_free (WkSlideshowItem *item);

#endif /* !WK_SLIDESHOW_ITEM */
