/**
 * Copyright (C) 2009-2010 Gauvain Pocentek <gpocentek@linutop.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef WK_VIDEO_H
#define WK_VIDEO_H

#include <gtk/gtk.h>

typedef struct _WkVideoPrivate WkVideoPrivate;
typedef struct _WkVideoClass   WkVideoClass;
typedef struct _WkVideo        WkVideo;

#define WK_TYPE_VIDEO             (wk_video_get_type ())
#define WK_VIDEO(obj)             (G_TYPE_CHECK_INSTANCE_CAST ((obj), WK_TYPE_VIDEO, WkVideo))
#define WK_VIDEO_CLASS(klass)     (G_TYPE_CHECK_CLASS_CAST ((klass), WK_TYPE_VIDEO, WkVideoClass))
#define WK_IS_VIDEO(obj)          (G_TYPE_CHECK_INSTANCE_TYPE ((obj), WK_TYPE_VIDEO))
#define WK_IS_VIDEO_CLASS(klass)  (G_TYPE_CHECK_CLASS_TYPE ((klass), WK_TYPE_VIDEO))
#define WK_VIDEO_GET_CLASS(obj)   (G_TYPE_INSTANCE_GET_CLASS ((obj), WK_TYPE_VIDEO, WkVideoClass))

struct _WkVideoClass
{
  GtkWidgetClass __parent__;

  /* signals */
  void (* end_reached) (GtkWidget *video);
};

struct _WkVideo
{
  GtkWidget __parent__;

  /*< private >*/
  WkVideoPrivate *priv;
};

GType      wk_video_get_type (void) G_GNUC_CONST G_GNUC_INTERNAL;

GtkWidget *wk_video_new (gboolean mute) G_GNUC_MALLOC G_GNUC_INTERNAL;

gboolean wk_video_play (WkVideo *video, const gchar *uri);
void     wk_video_stop (WkVideo *video);

#endif /* !WK_VIDEO_H */
